diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lte/model/lte-ue-rrc.cc ns-3.33/src/lte/model/lte-ue-rrc.cc
--- ns-3.32/src/lte/model/lte-ue-rrc.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lte/model/lte-ue-rrc.cc	2021-01-09 10:19:22.000000000 -0800
@@ -1059,152 +1058,148 @@
   NS_LOG_INFO ("DoRecvRrcConnectionReconfiguration haveNonCriticalExtension:" << msg.haveNonCriticalExtension);
   switch (m_state)
     {
-    case CONNECTED_NORMALLY:
-      if (msg.haveMobilityControlInfo)
-        {
-          NS_LOG_INFO ("haveMobilityControlInfo == true");
-          SwitchToState (CONNECTED_HANDOVER);
-          if (m_radioLinkFailureDetected.IsRunning ())
-            {
-              ResetRlfParams ();
-            }
-          const LteRrcSap::MobilityControlInfo& mci = msg.mobilityControlInfo;
-          m_handoverStartTrace (m_imsi, m_cellId, m_rnti, mci.targetPhysCellId);
-          //We should reset the MACs and PHYs for all the component carriers
-          for (uint16_t i = 0; i < m_numberOfComponentCarriers; i++)
-            {
-              m_cmacSapProvider.at(i)->Reset ();
-              m_cphySapProvider.at(i)->Reset ();
-            }
-          m_ccmRrcSapProvider->Reset();
-          StorePreviousCellId (m_cellId);
-          m_cellId = mci.targetPhysCellId;
-          NS_ASSERT (mci.haveCarrierFreq);
-          NS_ASSERT (mci.haveCarrierBandwidth);
-          m_cphySapProvider.at(0)->SynchronizeWithEnb (m_cellId, mci.carrierFreq.dlCarrierFreq);
-          m_cphySapProvider.at(0)->SetDlBandwidth ( mci.carrierBandwidth.dlBandwidth);
-          m_cphySapProvider.at(0)->ConfigureUplink (mci.carrierFreq.ulCarrierFreq, mci.carrierBandwidth.ulBandwidth);
-          m_rnti = msg.mobilityControlInfo.newUeIdentity;
-          m_srb0->m_rlc->SetRnti (m_rnti);
-          NS_ASSERT_MSG (mci.haveRachConfigDedicated, "handover is only supported with non-contention-based random access procedure");
-          m_cmacSapProvider.at(0)->StartNonContentionBasedRandomAccessProcedure (m_rnti, mci.rachConfigDedicated.raPreambleIndex, mci.rachConfigDedicated.raPrachMaskIndex);
-          m_cphySapProvider.at(0)->SetRnti (m_rnti);
-          m_lastRrcTransactionIdentifier = msg.rrcTransactionIdentifier;
-          NS_ASSERT (msg.haveRadioResourceConfigDedicated);
-
-          // we re-establish SRB1 by creating a new entity
-          // note that we can't dispose the old entity now, because
-          // it's in the current stack, so we would corrupt the stack
-          // if we did so. Hence we schedule it for later disposal
-          m_srb1Old = m_srb1;
-          Simulator::ScheduleNow (&LteUeRrc::DisposeOldSrb1, this);
-          m_srb1 = 0; // new instance will be be created within ApplyRadioResourceConfigDedicated
-
-          m_drbMap.clear (); // dispose all DRBs
-          ApplyRadioResourceConfigDedicated (msg.radioResourceConfigDedicated);
-          if (msg.haveNonCriticalExtension)
-            {
-              NS_LOG_DEBUG (this << "RNTI " << m_rnti << " Handover. Configuring secondary carriers");
-              ApplyRadioResourceConfigDedicatedSecondaryCarrier (msg.nonCriticalExtension);
-            }
+      case CONNECTED_NORMALLY:
+        if (msg.haveMobilityControlInfo)
+          {
+            NS_LOG_INFO ("haveMobilityControlInfo == true");
+            SwitchToState (CONNECTED_HANDOVER);
+            const LteRrcSap::MobilityControlInfo& mci = msg.mobilityControlInfo;
+            m_handoverStartTrace (m_imsi, m_cellId, m_rnti, mci.targetPhysCellId);
+            //We should reset the MACs and PHYs for all the component carriers
+            for (uint16_t i = 0; i < m_numberOfComponentCarriers; i++)
+              {
+                m_cmacSapProvider.at (i)->Reset ();
+                m_cphySapProvider.at (i)->Reset ();
+              }
+            m_ccmRrcSapProvider->Reset ();
+            StorePreviousCellId (m_cellId);
+            m_cellId = mci.targetPhysCellId;
+            NS_ASSERT (mci.haveCarrierFreq);
+            NS_ASSERT (mci.haveCarrierBandwidth);
+            m_cphySapProvider.at (0)->SynchronizeWithEnb (m_cellId, mci.carrierFreq.dlCarrierFreq);
+            m_cphySapProvider.at (0)->SetDlBandwidth ( mci.carrierBandwidth.dlBandwidth);
+            m_cphySapProvider.at (0)->ConfigureUplink (mci.carrierFreq.ulCarrierFreq, mci.carrierBandwidth.ulBandwidth);
+            m_rnti = msg.mobilityControlInfo.newUeIdentity;
+            m_srb0->m_rlc->SetRnti (m_rnti);
+            NS_ASSERT_MSG (mci.haveRachConfigDedicated, "handover is only supported with non-contention-based random access procedure");
+            m_cmacSapProvider.at (0)->StartNonContentionBasedRandomAccessProcedure (m_rnti, mci.rachConfigDedicated.raPreambleIndex, mci.rachConfigDedicated.raPrachMaskIndex);
+            m_cphySapProvider.at (0)->SetRnti (m_rnti);
+            m_lastRrcTransactionIdentifier = msg.rrcTransactionIdentifier;
+            NS_ASSERT (msg.haveRadioResourceConfigDedicated);
+
+            // we re-establish SRB1 by creating a new entity
+            // note that we can't dispose the old entity now, because
+            // it's in the current stack, so we would corrupt the stack
+            // if we did so. Hence we schedule it for later disposal
+            m_srb1Old = m_srb1;
+            Simulator::ScheduleNow (&LteUeRrc::DisposeOldSrb1, this);
+            m_srb1 = 0; // new instance will be be created within ApplyRadioResourceConfigDedicated
+
+            m_drbMap.clear (); // dispose all DRBs
+            ApplyRadioResourceConfigDedicated (msg.radioResourceConfigDedicated);
+            if (msg.haveNonCriticalExtension)
+              {
+                NS_LOG_DEBUG (this << "RNTI " << m_rnti << " Handover. Configuring secondary carriers");
+                ApplyRadioResourceConfigDedicatedSecondaryCarrier (msg.nonCriticalExtension);
+              }
 
-          if (msg.haveMeasConfig)
-            {
-              ApplyMeasConfig (msg.measConfig);
-            }
-          // RRC connection reconfiguration completed will be sent
-          // after handover is complete
-        }
-      else
-        {
-          NS_LOG_INFO ("haveMobilityControlInfo == false");
-          if (msg.haveNonCriticalExtension)
-            {
-              ApplyRadioResourceConfigDedicatedSecondaryCarrier (msg.nonCriticalExtension);
-              NS_LOG_DEBUG (this << "RNTI " << m_rnti << " Configured for CA" );
-            }
-          if (msg.haveRadioResourceConfigDedicated)
-            {
-              ApplyRadioResourceConfigDedicated (msg.radioResourceConfigDedicated);
-            } 
-          if (msg.haveMeasConfig)
-            {
-              ApplyMeasConfig (msg.measConfig);
-            }
-          LteRrcSap::RrcConnectionReconfigurationCompleted msg2;
-          msg2.rrcTransactionIdentifier = msg.rrcTransactionIdentifier;
-          m_rrcSapUser->SendRrcConnectionReconfigurationCompleted (msg2);
-          m_connectionReconfigurationTrace (m_imsi, m_cellId, m_rnti);
-        }
-      break;
+            if (msg.haveMeasConfig)
+              {
+                ApplyMeasConfig (msg.measConfig);
+              }
+            // RRC connection reconfiguration completed will be sent
+            // after handover is complete
+          }
+        else
+          {
+            NS_LOG_INFO ("haveMobilityControlInfo == false");
+            if (msg.haveNonCriticalExtension)
+              {
+                ApplyRadioResourceConfigDedicatedSecondaryCarrier (msg.nonCriticalExtension);
+                NS_LOG_DEBUG (this << "RNTI " << m_rnti << " Configured for CA" );
+              }
+            if (msg.haveRadioResourceConfigDedicated)
+              {
+                ApplyRadioResourceConfigDedicated (msg.radioResourceConfigDedicated);
+              }
+            if (msg.haveMeasConfig)
+              {
+                ApplyMeasConfig (msg.measConfig);
+              }
+            LteRrcSap::RrcConnectionReconfigurationCompleted msg2;
+            msg2.rrcTransactionIdentifier = msg.rrcTransactionIdentifier;
+            m_rrcSapUser->SendRrcConnectionReconfigurationCompleted (msg2);
+            m_connectionReconfigurationTrace (m_imsi, m_cellId, m_rnti);
+          }
+        break;
 
-    default:
-      NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
-      break;
+      default:
+        NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
+        break;
     }
 }
 
-void 
+void
 LteUeRrc::DoRecvRrcConnectionReestablishment (LteRrcSap::RrcConnectionReestablishment msg)
 {
   NS_LOG_FUNCTION (this << " RNTI " << m_rnti);
   switch (m_state)
     {
-    case CONNECTED_REESTABLISHING:
-      {
-        /**
-         * \todo After receiving RRC Connection Re-establishment, stop timer
-         *       T301, fire a new trace source, reply with RRC Connection
-         *       Re-establishment Complete, and finally switch to
-         *       CONNECTED_NORMALLY state. See Section 5.3.7.5 of 3GPP TS
-         *       36.331.
-         */
-      }
-      break;
-
-    default:
-      NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
-      break;
+      case CONNECTED_REESTABLISHING:
+        {
+          /**
+           * \todo After receiving RRC Connection Re-establishment, stop timer
+           *       T301, fire a new trace source, reply with RRC Connection
+           *       Re-establishment Complete, and finally switch to
+           *       CONNECTED_NORMALLY state. See Section 5.3.7.5 of 3GPP TS
+           *       36.331.
+           */
+        }
+        break;
+
+      default:
+        NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
+        break;
     }
 }
 
-void 
+void
 LteUeRrc::DoRecvRrcConnectionReestablishmentReject (LteRrcSap::RrcConnectionReestablishmentReject msg)
 {
   NS_LOG_FUNCTION (this << " RNTI " << m_rnti);
   switch (m_state)
     {
-    case CONNECTED_REESTABLISHING:
-      {
-        /**
-         * \todo After receiving RRC Connection Re-establishment Reject, stop
-         *       timer T301. See Section 5.3.7.8 of 3GPP TS 36.331.
-         */
-        m_asSapUser->NotifyConnectionReleased (); // Inform upper layers
-      }
-      break;
-
-    default:
-      NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
-      break;
+      case CONNECTED_REESTABLISHING:
+        {
+          /**
+           * \todo After receiving RRC Connection Re-establishment Reject, stop
+           *       timer T301. See Section 5.3.7.8 of 3GPP TS 36.331.
+           */
+          m_asSapUser->NotifyConnectionReleased (); // Inform upper layers
+        }
+        break;
+
+      default:
+        NS_FATAL_ERROR ("method unexpected in state " << ToString (m_state));
+        break;
     }
 }
 
-void 
+void
 LteUeRrc::DoRecvRrcConnectionRelease (LteRrcSap::RrcConnectionRelease msg)
 {
   NS_LOG_FUNCTION (this << " RNTI " << m_rnti);
   /// \todo Currently not implemented, see Section 5.3.8 of 3GPP TS 36.331.
 }
 
-void 
+void
 LteUeRrc::DoRecvRrcConnectionReject (LteRrcSap::RrcConnectionReject msg)
 {
   NS_LOG_FUNCTION (this);
   m_connectionTimeout.Cancel ();
   for (uint16_t i = 0; i < m_numberOfComponentCarriers; i++)
     {
-      m_cmacSapProvider.at(i)->Reset (); // reset the MAC
+      m_cmacSapProvider.at (i)->Reset (); // reset the MAC
     }
   m_hasReceivedSib2 = false;         // invalidate the previously received SIB2
   SwitchToState (IDLE_CAMPED_NORMALLY);
@@ -1257,7 +1252,7 @@
     {
       NS_LOG_LOGIC (this << " cell " << maxRsrpCellId
                          << " is the strongest untried surrounding cell");
-      m_cphySapProvider.at(0)->SynchronizeWithEnb (maxRsrpCellId, m_dlEarfcn);
+      m_cphySapProvider.at (0)->SynchronizeWithEnb (maxRsrpCellId, m_dlEarfcn);
       SwitchToState (IDLE_WAIT_MIB_SIB1);
     }
 
@@ -1302,8 +1297,8 @@
   if (isSuitableCell)
     {
       m_cellId = cellId;
-      m_cphySapProvider.at(0)->SynchronizeWithEnb (cellId, m_dlEarfcn);
-      m_cphySapProvider.at(0)->SetDlBandwidth (m_dlBandwidth);
+      m_cphySapProvider.at (0)->SynchronizeWithEnb (cellId, m_dlEarfcn);
+      m_cphySapProvider.at (0)->SetDlBandwidth (m_dlBandwidth);
       m_initialCellSelectionEndOkTrace (m_imsi, cellId);
       // Once the UE is connected, m_connectionPending is
       // set to false. So, when RLF occurs and UE performs
@@ -1352,7 +1347,7 @@
 
   m_sCellToAddModList = nonCec.sCellsToAddModList;
 
-  for(std::list<LteRrcSap::SCellToAddMod>::iterator it = nonCec.sCellsToAddModList.begin(); it!=nonCec.sCellsToAddModList.end(); it++)
+  for (std::list<LteRrcSap::SCellToAddMod>::iterator it = nonCec.sCellsToAddModList.begin (); it != nonCec.sCellsToAddModList.end (); it++)
     {
       LteRrcSap::SCellToAddMod scell = *it;
       uint8_t ccId = scell.sCellIndex;
@@ -1371,8 +1366,8 @@
       m_cphySapProvider.at (ccId)->ConfigureUplink (ulEarfcn, ulBand);
       m_cphySapProvider.at (ccId)->ConfigureReferenceSignalPower (scell.radioResourceConfigCommonSCell.nonUlConfiguration.pdschConfigCommon.referenceSignalPower);
       m_cphySapProvider.at (ccId)->SetTransmissionMode (txMode);
-      m_cphySapProvider.at (ccId)->SetRnti(m_rnti);
-      m_cmacSapProvider.at (ccId)->SetRnti(m_rnti);
+      m_cphySapProvider.at (ccId)->SetRnti (m_rnti);
+      m_cmacSapProvider.at (ccId)->SetRnti (m_rnti);
       // update PdschConfigDedicated (i.e. P_A value)
       LteRrcSap::PdschConfigDedicated pdschConfigDedicated = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.pdschConfigDedicated;
       double paDouble = LteRrcSap::ConvertPdschConfigDedicated2Double (pdschConfigDedicated);
@@ -1383,7 +1378,7 @@
   m_sCarrierConfiguredTrace (this, m_sCellToAddModList);
 }
 
-void 
+void
 LteUeRrc::ApplyRadioResourceConfigDedicated (LteRrcSap::RadioResourceConfigDedicated rrcd)
 {
   NS_LOG_FUNCTION (this);
@@ -1391,11 +1386,11 @@
 
   if (pcd.haveAntennaInfoDedicated)
     {
-      m_cphySapProvider.at(0)->SetTransmissionMode (pcd.antennaInfo.transmissionMode);
+      m_cphySapProvider.at (0)->SetTransmissionMode (pcd.antennaInfo.transmissionMode);
     }
   if (pcd.haveSoundingRsUlConfigDedicated)
     {
-      m_cphySapProvider.at(0)->SetSrsConfigurationIndex (pcd.soundingRsUlConfigDedicated.srsConfigIndex);
+      m_cphySapProvider.at (0)->SetSrsConfigurationIndex (pcd.soundingRsUlConfigDedicated.srsConfigIndex);
     }
 
   if (pcd.havePdschConfigDedicated)
@@ -1403,7 +1398,7 @@
       // update PdschConfigDedicated (i.e. P_A value)
       m_pdschConfigDedicated = pcd.pdschConfigDedicated;
       double paDouble = LteRrcSap::ConvertPdschConfigDedicated2Double (m_pdschConfigDedicated);
-      m_cphySapProvider.at(0)->SetPa (paDouble);
+      m_cphySapProvider.at (0)->SetPa (paDouble);
     }
 
   std::list<LteRrcSap::SrbToAddMod>::const_iterator stamIt = rrcd.srbToAddModList.begin ();
@@ -1411,8 +1406,8 @@
     {
       if (m_srb1 == 0)
         {
-          // SRB1 not setup yet        
-          NS_ASSERT_MSG ((m_state == IDLE_CONNECTING) || (m_state == CONNECTED_HANDOVER), 
+          // SRB1 not setup yet
+          NS_ASSERT_MSG ((m_state == IDLE_CONNECTING) || (m_state == CONNECTED_HANDOVER),
                          "unexpected state " << ToString (m_state));
           NS_ASSERT_MSG (stamIt->srbIdentity == 1, "only SRB1 supported");
 
@@ -1421,7 +1416,7 @@
           Ptr<LteRlc> rlc = CreateObject<LteRlcAm> ();
           rlc->SetLteMacSapProvider (m_macSapProvider);
           rlc->SetRnti (m_rnti);
-          rlc->SetLcId (lcid);      
+          rlc->SetLcId (lcid);
 
           Ptr<LtePdcp> pdcp = CreateObject<LtePdcp> ();
           pdcp->SetRnti (m_rnti);
@@ -1446,11 +1441,11 @@
           lcConfig.prioritizedBitRateKbps = stamIt->logicalChannelConfig.prioritizedBitRateKbps;
           lcConfig.bucketSizeDurationMs = stamIt->logicalChannelConfig.bucketSizeDurationMs;
           lcConfig.logicalChannelGroup = stamIt->logicalChannelConfig.logicalChannelGroup;
-          LteMacSapUser* msu = m_ccmRrcSapProvider->ConfigureSignalBearer(lcid, lcConfig, rlc->GetLteMacSapUser ());
+          LteMacSapUser* msu = m_ccmRrcSapProvider->ConfigureSignalBearer (lcid, lcConfig, rlc->GetLteMacSapUser ());
           m_cmacSapProvider.at (0)->AddLc (lcid, lcConfig, msu);
           ++stamIt;
           NS_ASSERT_MSG (stamIt == rrcd.srbToAddModList.end (), "at most one SrbToAdd supported");
-          
+
           LteUeRrcSapUser::SetupParameters ueParams;
           ueParams.srb0SapProvider = m_srb0->m_rlc->GetLteRlcSapProvider ();
           ueParams.srb1SapProvider = m_srb1->m_pdcp->GetLtePdcpSapProvider ();
@@ -1476,7 +1471,7 @@
       if (drbMapIt == m_drbMap.end ())
         {
           NS_LOG_INFO ("New Data Radio Bearer");
-        
+
           TypeId rlcTypeId;
           if (m_useRlcSm)
             {
@@ -1486,20 +1481,20 @@
             {
               switch (dtamIt->rlcConfig.choice)
                 {
-                case LteRrcSap::RlcConfig::AM: 
-                  rlcTypeId = LteRlcAm::GetTypeId ();
-                  break;
-          
-                case LteRrcSap::RlcConfig::UM_BI_DIRECTIONAL: 
-                  rlcTypeId = LteRlcUm::GetTypeId ();
-                  break;
-          
-                default:
-                  NS_FATAL_ERROR ("unsupported RLC configuration");
-                  break;                
+                  case LteRrcSap::RlcConfig::AM:
+                    rlcTypeId = LteRlcAm::GetTypeId ();
+                    break;
+
+                  case LteRrcSap::RlcConfig::UM_BI_DIRECTIONAL:
+                    rlcTypeId = LteRlcUm::GetTypeId ();
+                    break;
+
+                  default:
+                    NS_FATAL_ERROR ("unsupported RLC configuration");
+                    break;
                 }
             }
-  
+
           ObjectFactory rlcObjectFactory;
           rlcObjectFactory.SetTypeId (rlcTypeId);
           Ptr<LteRlc> rlc = rlcObjectFactory.Create ()->GetObject<LteRlc> ();
@@ -1512,7 +1507,7 @@
           drbInfo->m_epsBearerIdentity = dtamIt->epsBearerIdentity;
           drbInfo->m_logicalChannelIdentity = dtamIt->logicalChannelIdentity;
           drbInfo->m_drbIdentity = dtamIt->drbIdentity;
- 
+
           // we need PDCP only for real RLC, i.e., RLC/UM or RLC/AM
           // if we are using RLC/SM we don't care of anything above RLC
           if (rlcTypeId != LteRlcSm::GetTypeId ())
@@ -1527,7 +1522,7 @@
             }
 
           m_bid2DrbidMap[dtamIt->epsBearerIdentity] = dtamIt->drbIdentity;
-  
+
           m_drbMap.insert (std::pair<uint8_t, Ptr<LteDataRadioBearerInfo> > (dtamIt->drbIdentity, drbInfo));
 
           m_drbCreatedTrace (m_imsi, m_cellId, m_rnti, dtamIt->drbIdentity);
@@ -1539,24 +1534,24 @@
           lcConfig.bucketSizeDurationMs = dtamIt->logicalChannelConfig.bucketSizeDurationMs;
           lcConfig.logicalChannelGroup = dtamIt->logicalChannelConfig.logicalChannelGroup;
 
-          NS_LOG_DEBUG (this << " UE RRC RNTI " << m_rnti << " Number Of Component Carriers "<<m_numberOfComponentCarriers<< " lcID " << (uint16_t) dtamIt->logicalChannelIdentity);
+          NS_LOG_DEBUG (this << " UE RRC RNTI " << m_rnti << " Number Of Component Carriers " << m_numberOfComponentCarriers << " lcID " << (uint16_t) dtamIt->logicalChannelIdentity);
           //Call AddLc of UE component carrier manager
           std::vector <LteUeCcmRrcSapProvider::LcsConfig> lcOnCcMapping = m_ccmRrcSapProvider->AddLc (dtamIt->logicalChannelIdentity, lcConfig, rlc->GetLteMacSapUser ());
 
-         NS_LOG_DEBUG ("Size of lcOnCcMapping vector "<<lcOnCcMapping.size());
-         std::vector<LteUeCcmRrcSapProvider::LcsConfig>::iterator itLcOnCcMapping = lcOnCcMapping.begin ();
-         NS_ASSERT_MSG (itLcOnCcMapping != lcOnCcMapping.end (), "Component carrier manager failed to add LC for data radio bearer");
-
-         for (itLcOnCcMapping = lcOnCcMapping.begin (); itLcOnCcMapping != lcOnCcMapping.end (); ++itLcOnCcMapping)
-           {
-             NS_LOG_DEBUG ("RNTI " << m_rnti
-                           << " LCG id " << (uint16_t) itLcOnCcMapping->lcConfig.logicalChannelGroup
-                           << " ComponentCarrierId " << (uint16_t) itLcOnCcMapping->componentCarrierId);
-             uint8_t index = itLcOnCcMapping->componentCarrierId;
-             LteUeCmacSapProvider::LogicalChannelConfig lcConfigFromCcm = itLcOnCcMapping->lcConfig;
-             LteMacSapUser *msu = itLcOnCcMapping->msu;
-             m_cmacSapProvider.at (index)->AddLc (dtamIt->logicalChannelIdentity, lcConfigFromCcm, msu);
-           }
+          NS_LOG_DEBUG ("Size of lcOnCcMapping vector " << lcOnCcMapping.size ());
+          std::vector<LteUeCcmRrcSapProvider::LcsConfig>::iterator itLcOnCcMapping = lcOnCcMapping.begin ();
+          NS_ASSERT_MSG (itLcOnCcMapping != lcOnCcMapping.end (), "Component carrier manager failed to add LC for data radio bearer");
+
+          for (itLcOnCcMapping = lcOnCcMapping.begin (); itLcOnCcMapping != lcOnCcMapping.end (); ++itLcOnCcMapping)
+            {
+              NS_LOG_DEBUG ("RNTI " << m_rnti
+                                    << " LCG id " << (uint16_t) itLcOnCcMapping->lcConfig.logicalChannelGroup
+                                    << " ComponentCarrierId " << (uint16_t) itLcOnCcMapping->componentCarrierId);
+              uint8_t index = itLcOnCcMapping->componentCarrierId;
+              LteUeCmacSapProvider::LogicalChannelConfig lcConfigFromCcm = itLcOnCcMapping->lcConfig;
+              LteMacSapUser *msu = itLcOnCcMapping->msu;
+              m_cmacSapProvider.at (index)->AddLc (dtamIt->logicalChannelIdentity, lcConfigFromCcm, msu);
+            }
 
           rlc->Initialize ();
         }
@@ -1567,7 +1562,7 @@
           /// \todo currently not implemented. Would need to modify drbInfo, and then propagate changes to the MAC
         }
     }
-  
+
   std::list<uint8_t>::iterator dtdmIt;
   for (dtdmIt = rrcd.drbToReleaseList.begin ();
        dtdmIt != rrcd.drbToReleaseList.end ();
@@ -1577,23 +1572,23 @@
       NS_LOG_INFO (this << " IMSI " << m_imsi << " releasing DRB " << (uint32_t) drbid);
       std::map<uint8_t, Ptr<LteDataRadioBearerInfo> >::iterator it =   m_drbMap.find (drbid);
       NS_ASSERT_MSG (it != m_drbMap.end (), "could not find bearer with given lcid");
-      m_drbMap.erase (it);      
+      m_drbMap.erase (it);
       m_bid2DrbidMap.erase (drbid);
       //Remove LCID
       for (uint32_t i = 0; i < m_numberOfComponentCarriers; i++)
-       {
-         m_cmacSapProvider.at (i)->RemoveLc (drbid + 2);
-       }
+        {
+          m_cmacSapProvider.at (i)->RemoveLc (drbid + 2);
+        }
     }
 }
 
 
-void 
+void
 LteUeRrc::ApplyMeasConfig (LteRrcSap::MeasConfig mc)
 {
   NS_LOG_FUNCTION (this);
 
-  // perform the actions specified in 3GPP TS 36.331 section 5.5.2.1 
+  // perform the actions specified in 3GPP TS 36.331 section 5.5.2.1
 
   // 3GPP TS 36.331 section 5.5.2.4 Measurement object removal
   for (std::list<uint8_t>::iterator it = mc.measObjectToRemoveList.begin ();
@@ -1641,7 +1636,7 @@
         {
           NS_LOG_LOGIC ("measObjectId " << (uint32_t) measObjectId << " exists, updating entry");
           measObjectIt->second = *it;
-          for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt 
+          for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt
                  = m_varMeasConfig.measIdList.begin ();
                measIdIt != m_varMeasConfig.measIdList.end ();
                ++measIdIt)
@@ -1705,7 +1700,7 @@
         {
           NS_LOG_LOGIC ("reportConfigId " << (uint32_t) reportConfigId << " exists, updating entry");
           m_varMeasConfig.reportConfigList[reportConfigId] = *it;
-          for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt 
+          for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt
                  = m_varMeasConfig.measIdList.begin ();
                measIdIt != m_varMeasConfig.measIdList.end ();
                ++measIdIt)
@@ -1851,7 +1846,7 @@
       v.rsrq = rsrq;
       std::pair<uint16_t, MeasValues> val (cellId, v);
       std::pair<std::map<uint16_t, MeasValues>::iterator, bool>
-        ret = m_storedMeasValues.insert (val);
+      ret = m_storedMeasValues.insert (val);
       NS_ASSERT_MSG (ret.second == true, "element already existed");
       storedMeasIt = ret.first;
     }
